;*******************************************************************************
;* Digitlis technika (VIMIAA03) 10. gyakorlat s laboratrium                 *
;* Legnagyobb kzs oszt szmtsa szoftveresen.                              *
;*******************************************************************************
DEF SW   0x81                ; DIP kapcsol adatregiszter           (csak olvashat)
DEF BT   0x84                ; Nyomgomb adatregiszter              (csak olvashat)
DEF DIG0 0x90                ; Kijelz DIG0 adatregiszter           (rhat/olvashat)
DEF DIG1 0x91                ; Kijelz DIG1 adatregiszter           (rhat/olvashat)
DEF DIG2 0x92                ; Kijelz DIG2 adatregiszter           (rhat/olvashat)
DEF DIG3 0x93                ; Kijelz DIG3 adatregiszter           (rhat/olvashat)


;*******************************************************************************
;* A program kezdete. A programmemria 0x00 s a 0x01 cme a reset, illetve    *
;* a megszakts vektor. Ide ugr utastsokat kell elhelyezni, amelyek a      *
;* megfelel programrszre ugranak. Ha nem hasznlunk megszaktst, akkor a    *
;* program kezddhet a 0x00 cmen is.                                          *
;*******************************************************************************
start:
    
read_a:
    
read_b:
    
gcd_loop:                       ;Az LNKO szmts kezdete.
    
a_gt_b:                         ;A > B eset.

    jmp     gcd_loop            ;Ugrs a ciklus elejre.
    
b_gt_a:                         ;A < B eset.

    jmp     gcd_loop            ;Ugrs a cuklus elejre.
    

;*******************************************************************************
;* Kt digites megjelents a htszegmenses kijelzn.                          *
;* Paramterek:                                                                *
;*   r8: A megjelentend szm.                                                *
;*   r9: Az egyesek helyirtkhez tartoz digit regiszter cme.               *
;*******************************************************************************
disp_wr:

    rts                         ;Visszatrs a hvhoz.


;*******************************************************************************
;* Kt digites BCD kivons.                                                    *
;* Paramterek:                                                                *
;*   r8: Kisebbtend.                                                         *
;*   r9: Kivonand.                                                            *
;* Visszatrsi rtk:                                                         *
;*   r8: Klnbsg.                                                            *
;*******************************************************************************
;bcd_sub:
    ;mov     r10, r8             ;Msolat ksztse a kisebbtendrl.
    ;mov     r11, r9             ;Msolat ksztse a kivonandrl.
    ;and     r10, #0x0f          ;A fels 4 bit trlse a msolatokban.
    ;and     r11, #0x0f
    ;sub     r10, r11            ;A kivons elvgzse az egyesek helyirtkn.
    ;mov     r11, r10            ;Msolat ksztse a klnbsgrl.
    ;tst     r10, #0x10          ;A 4 bites klnbsg negatv (volt tvitel)?
    ;jz      no_corr1            ;Ugrs, ha nem.
    ;add     r10, #0x0a          ;Negatv klnbsg esetn BCD korrekci (+10).
;no_corr1:
    ;and     r10, #0x0f          ;A klnbsg als 4 bitje kell csak.
    ;and     r11, #0x10          ;A msolatbl az tvitel kell csak.
    
    ;and     r8, #0xf0           ;Az als 4 bit trlse az eredeti adatokban.
    ;and     r9, #0xf0
    ;add     r9, r11             ;A kivonandhoz hozzadjuk az tvitelt.
    ;sub     r8, r9              ;A kivons elvgzse a tizesek helyirtkn.
    ;jnc     no_corr10           ;Ugrs, ha a klnbsg nemnegatv.
    ;add     r8, #0xa0           ;Negatv klnbsg esetn BCD korrekci (+10).
;no_corr10:

    ;or      r8, r10             ;A teljes 2 digites klnbsg.
    ;rts                         ;Visszatrs a hvhoz.


;*******************************************************************************
;* Az adatmemria inicializlsa a htszegmenses dekder tblzattal.          *
;*******************************************************************************
    DATA
    
bin_7seg:
    DB      0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07
    DB      0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71
    